/*	This was created with the LiPG parser generator written by Billy Tetrud.
	Email BillyAtLima@gmail.com if you want to discuss creating a different license.
	Copyright 2008, Billy Tetrud.
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License.
	as published by the Free Software Foundation; either version 3, or (at your option) any later version.
	
	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
*/

bool ws(int* limas_NOW, char* limas_input, int limas_length);
bool quote(int* limas_NOW, char* limas_input, int limas_length, char* X);
bool singleQuote(int* limas_NOW, char* limas_input, int limas_length, char* X);
bool word(int* limas_NOW, char* limas_input, int limas_length, char* X);
bool theLanguage(int* limas_NOW, char* limas_input, int limas_length);
bool multiLine_C_Comment(int* limas_NOW, char* limas_input, int limas_length, char* X);
bool crapBracket(int* limas_NOW, char* limas_input, int limas_length, char* X, bool notzeroOne, bool now0);
bool theParse(int* limas_NOW, char* limas_input, int limas_length);
bool outputs(int* limas_NOW, char* limas_input, int limas_length, char* X);
bool anychars(int* limas_NOW, char* limas_input, int limas_length);
bool anycharStrings(int* limas_NOW, char* limas_input, int limas_length);
bool alwaysAndBetween(int* limas_NOW, char* limas_input, int limas_length);
bool wordformChoice(int* limas_NOW, char* limas_input, int limas_length);
bool setOfChoices(int* limas_NOW, char* limas_input, int limas_length);
bool arrow(int* limas_NOW, char* limas_input, int limas_length,  char* X);
bool choice(int* limas_NOW, char* limas_input, int limas_length);
bool wordform(int* limas_NOW, char* limas_input, int limas_length);
bool conditional(int* limas_NOW, char* limas_input, int limas_length, char* X);
bool multiForm(int* limas_NOW, char* limas_input, int limas_length);
bool function(int* limas_NOW, char* limas_input, int limas_length, char* X);


	/*	This file was created by Billy Tetrud in November 2008. 
		This file is realeased under version 3 of the GNU Public License. See http://www.gnu.org/licenses/
		A copy of GPLv3 should be distributed with this file.
		Email BillyAtLima@gmail.com if you want to discuss creating a different license.
		Copyright 2008, Billy Tetrud.
		
		This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License 
		as published by the Free Software Foundation; either version 3, or (at your option) any later version.

		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
	*/
	#include <stdio.h>
	#include <string.h>
	#include "theStrings v080218.h"
	#include "basicDynamicTypesv080206.h"
	#include <time.h>
	
	int testallEQ(char* a, char* equals);
	char* twoDLiteralString(char* a, char*b, char out[][2]);
	int SL(char* x);
	int SL(char x);
	int testallNEQ(char* a, char between1, char between2);
	int testallNEQ(char* a, char Nequals);

	void strcpy(BDArr<char>& inThis, char* putThis);

	void strcat(BDArr<char>& atEndOfThis, BDArr<char>& putThis);
	void strcat(BDArr<char>& atEndOfThis, char* putThis);
	void strcat(BDArr<char>& atEndOfThis, char* putThis, int dumdum);
	void strcat(BDArr<char>& atEndOfThis, char putThis,  int dumdum);
	void strcat(BDArr<char>& atEndOfThis, char putThis);
	
	bool main_already, notween, noevery, in_tween, in_every, in_else, everyExists, tweenExists, debug;
	int CI, nNumber, forNum, choiceSetNumber, elseNumber, wordformNumber, NOWtempNumbersDeclared, NOWtempNumber;
	char sMultTemp[50];
	char anyN[50];
	
	BDArr<char> output_top;
	BDArr<char> output_middle;
	BDArr<char> output_bottom;
	
	BDArr<char> onFailBlock;
	BDArr<char> onMismatchBlock;
	
	BDArr<char[50]> anychar_vars;
	BDArr<char[50]> anycharString_vars;
	BDArr<char[100]> theOrder;			// keeps the peices of the wordform
	BDArr<char[100]> tweenOrder;		// keeps the peices of tweens wordform
	BDArr<char[2][1000]> buildBlocks;	// keeps the anychar variable name indexed with its build conditions
	
	BDArr<char[20000]> theActions;
	BDArr<char[50]> theLabel;
	
	BDArr<char> failStack;				// used to report errors and give insight as to where the error occurred
	
	void setupForChoices();		// sets up for a set of a wordform choices
	void cleanUpAfterChoices();
	
	void setupForWordform();	// sets up for a single wordform
	
	void handleString(char* string);
	void handleAnychar(char* word, char* buildBlock, bool isAnycharString);
	void handleWord(char* word, char* buildBlock);
	void handleFunction(char* func);	
	
	bool isAnycharString(char* in);
	bool isAnychar(char* in);
	char* transformIfAnychar(char* in, bool notZeroOne, bool now0);	// changes an anychar into the limas_X format
	
	class theNewLinesClass
	{public:
		BDArr<int> newLineCharacterPositions;		// holds the character positions of each newline (in order)
		int lastLine;		// the highest line added
		int lastChar;
		
		theNewLinesClass()
		{	newLineCharacterPositions.length=0;
			lastLine=1;
			lastChar=-1;
		}
		
		void add(int charPos)
		{	if(charPos<=lastChar)
			{	return;
			}
			newLineCharacterPositions[newLineCharacterPositions.length] = charPos;
			lastLine+=1;
			lastChar = charPos;
		}
		
		void addString(BDArr<char>& input)
		{	newLineCharacterPositions.length = 0;
			lastLine=1;
			lastChar=-1;
			for(int n=0; n<input.length; n++)
			{	if(input[n]=='\n')
				{	add((int)(&(input[n])));	
				}
			}	
		}
		
		int getLine(int charPos)	// returns line number from character position
		{	if(charPos>lastChar)
			{	return lastLine;
			}
			
			for(int n=0; n<newLineCharacterPositions.length; n++)
			{	if(charPos<newLineCharacterPositions[n])
				{	return n+1;
				}
			}
		}
	};
	
	theNewLinesClass theNewLines;
	
	void outputFail(char* theNow, char* funcName)
	{	strcat(failStack, funcName);
		strcat(failStack, " failed on line ");
		strcat(failStack, itS(theNewLines.getLine((int)theNow), sMultTemp));
		strcat(failStack, ": '");
		for(int n=0; n<10; n++)
		{	strcat(failStack, theNow[n]);
		}	
		strcat(failStack, "'\n");
	}
	
	void choiceMismatch(char* theNow)
	{	strcat(failStack, " - a wordform failed on line ");
		strcat(failStack, itS(theNewLines.getLine((int)theNow), sMultTemp));
		strcat(failStack, ": '");
		for(int n=0; n<10; n++)
		{	strcat(failStack, theNow[n]);
		}	
		strcat(failStack, "'\n");
	}

	// clips everything after the last dot in the file name
	// if there is no dot, it won't clip anything
	void clipExtension(char* filename)
	{	int NofLastDot=-1;
		for(int n=0; filename[n]!=0; n++)
		{	if(filename[n]=='.')
			{	NofLastDot = n;
			}
		}	
		if(NofLastDot>0)
		{	filename[NofLastDot]=0;	
		}
	}

	main(int argc, char** argv)		//////////////////////////////////////////////////////////////////////////////////
	{	char filename[100];
		
		if(argc==2)
		{	strcpy(filename, argv[1]);
		}
		else if(argc>2)
		{	printf("You input too many command-line arguments. LPG takes just one. (press enter to quit)\n");
			getchar();
			exit(0);
		}
		else
		{	printf("Enter a file: ");
			strcpy(filename, "");
			char x; 
			int n=0;
			for(; (x=getchar())!='\n'; n++)
			{	filename[n]= x;
			}
			filename[n]=0;
		}
		
		BDArr<char> input;
		FILE* inputFile = fopen(filename, "r");
		if(inputFile==0)
		{	printf("The file you want to parse (%s) isn't there.. good job. (press enter to quit)\n", filename);
			getchar();
			exit(0);
		}
		char foodTemp;
		int food;
		bool joker=false;
		
		output_top.length=0;
		output_middle.length=0;
		output_bottom.length=0;
		
		for(food=0; (foodTemp = fgetc(inputFile))!=-1; food++)
		{	input[food] = foodTemp;
		}	
		
		input[food]=0;
		fclose(inputFile);
		
		int a;
		a=clock();
		
		debug = false;
		theNewLines.addString(input);
		
		int CURpos=0;
		int upchuck=0;
		printf("Parsing %s ...\n", filename);
		bool succeeded = theLanguage(&upchuck, &(input[0]), food);
		
		printf("\n-\tIt took %d clock ticks\n\n", clock()-a);
		
		if(succeeded)
		{	FILE* file;		// file to compile
			char fileNameTemp[100];
			clipExtension(filename);
			strcpy(fileNameTemp, filename);
			strcat(fileNameTemp, ".cpp");
			
			file = fopen(fileNameTemp, "w");
		
			fprintf(file, "/*	This was created with the LiPG parser generator written by Billy Tetrud.\n");
			fprintf(file, "	Email BillyAtLima@gmail.com if you want to discuss creating a different license.\n");
			fprintf(file, "	Copyright 2008, Billy Tetrud.\n");
			fprintf(file, "	\n");
			fprintf(file, "	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License.\n");
			fprintf(file, "	as published by the Free Software Foundation; either version 3, or (at your option) any later version.\n");
			fprintf(file, "	\n");
			fprintf(file, "	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
			fprintf(file, "	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.\n");
			fprintf(file, "*/\n\n");
		
			char damnittemp;
			for(int n=0; n<output_top.len(); n++)
			{	fprintf(file, "%c",output_top[n]);
			}
			for(int n=0; n<output_middle.len(); n++)
			{	fprintf(file, "%c",output_middle[n]);
			}
			fprintf(file, "\n\n");
			
			fclose(file);
			
			//printf("Now compiling...\n");
			//system("C:\\Dev-Cpp\\bin\\g++.exe G11output.cpp -o G11output.exe");
			
			printf("Finally Done!\n");
			printf("Output to '%s'\n", fileNameTemp);
		}
		else
		{	debug=true;
			if(theLanguage(&upchuck, &(input[0]), food))
			{	printf("The language failed the first time, but not the second time... weird...\n");
			}
			
			
			failStack[failStack.length]=0;
			printf("%s\n", &(failStack[0]));
			printf("Failed (%d total ticks).\n", clock()-a);
			getchar();
		}
		
		
	
	}

bool ws(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	int an;
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int NOWtemp1;
		NOWtemp1 = *limas_NOW;
		limas_Wo_max[zeroOne] = limas_length-*limas_NOW;
		for(; wordL[zeroOne] == -1 && limas_Wo_max[zeroOne]>=0; limas_Wo_max[zeroOne]-=1)	// Wo
		{	*limas_NOW = NOWtemp1;
			for(an=0; an<limas_Wo_max[zeroOne]; an+=1)			// build Wo
			{	limas_Wo[zeroOne][an] = limas_input[*limas_NOW];
				if( limas_Wo[zeroOne][an]==' ' || limas_Wo[zeroOne][an]=='\t' || limas_Wo[zeroOne][an]=='\n' )
				{	*limas_NOW += 1;
				}
				else
				{	limas_Wo[zeroOne][an] = 0;
					break;
					an = 0;
				}
			}
			limas_Wo[zeroOne][an] = 0;
			limas_Wo_max[zeroOne] = an;
			wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		return true;		
	}
	else 
	{
		failStack.length=0;
		return true; // success
	
	}
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "ws");
	
	return false;
}


bool quote(int* limas_NOW, char* limas_input, int limas_length, char* X)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	int an;
	char limas_ao[2], limas_bo[2];
	int limas_ao_max[2], limas_bo_max[2];
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("\""[n0] !=0 && "\""[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("\""[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(X,"");
	
	}
	else
		goto LIMAsEndOfParseFunction;
more: //->
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int NOWtemp1;
		NOWtemp1 = *limas_NOW;
		limas_Wo_max[zeroOne] = limas_length-*limas_NOW;
		for(; wordL[zeroOne] == -1 && limas_Wo_max[zeroOne]>=0; limas_Wo_max[zeroOne]-=1)	// Wo
		{	*limas_NOW = NOWtemp1;
			for(an=0; an<limas_Wo_max[zeroOne]; an+=1)			// build Wo
			{	limas_Wo[zeroOne][an] = limas_input[*limas_NOW];
				if( limas_Wo[zeroOne][an]!='\\' && limas_Wo[zeroOne][an]!='"' )
				{	*limas_NOW += 1;
				}
				else
				{	limas_Wo[zeroOne][an] = 0;
					break;
					an = 0;
				}
			}
			limas_Wo[zeroOne][an] = 0;
			limas_Wo_max[zeroOne] = an;
			wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("\\"[n0] !=0 && "\\"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("\\"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		int NOWtemp2;
		NOWtemp2 = *limas_NOW;
		if(limas_length-*limas_NOW > 0)
			limas_bo_max[zeroOne] = 1;
		else
			limas_bo_max[zeroOne] = 0;
		for(; wordL[zeroOne] == -1 && limas_bo_max[zeroOne]>=0; limas_bo_max[zeroOne]-=1)	// bo
		{	*limas_NOW = NOWtemp2;
			limas_bo[zeroOne] = 0;
			for(an=0; an<limas_bo_max[zeroOne]; an+=1)			// build bo
			{	limas_bo[zeroOne] = limas_input[*limas_NOW];
				if(1)
				{	*limas_NOW += 1;
				}
				else
				{	limas_bo[zeroOne] = 0;
					break;
					an = 0;
				}
			}
			limas_bo_max[zeroOne] = an;
			if( limas_bo[zeroOne]!=0 )
			{	wordL[zeroOne] = *limas_NOW-NOWtemp0;
			}
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 1;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n1=0;
		while("\n"[n1] !=0 && "\n"[n1]==(&(limas_input[*limas_NOW]))[n1])	// string
		{	n1+=1;
		}
		if("\n"[n1]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n1;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 2;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n2=0;
		while("\""[n2] !=0 && "\""[n2]==(&(limas_input[*limas_NOW]))[n2])	// string
		{	n2+=1;
		}
		if("\""[n2]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n2;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 3;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X,limas_Wo[!zeroOne]);
	
		goto more;
	}
	else if(longest == 1 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, "\\");
		strcat(X, limas_bo[!zeroOne]);
	
		goto more;
	}
	else if(longest == 2 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, "\n");	
	
		goto more;
	}
	else if(longest == 3 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		failStack.length=0;
		return true;
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "quote");
	
	return false;
}


bool singleQuote(int* limas_NOW, char* limas_input, int limas_length, char* X)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	int an;
	char limas_ao[2], limas_bo[2];
	int limas_ao_max[2], limas_bo_max[2];
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("'"[n0] !=0 && "'"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("'"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(X,"");
	
	}
	else
		goto LIMAsEndOfParseFunction;
more: //->
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int NOWtemp1;
		NOWtemp1 = *limas_NOW;
		limas_Wo_max[zeroOne] = limas_length-*limas_NOW;
		for(; wordL[zeroOne] == -1 && limas_Wo_max[zeroOne]>=0; limas_Wo_max[zeroOne]-=1)	// Wo
		{	*limas_NOW = NOWtemp1;
			for(an=0; an<limas_Wo_max[zeroOne]; an+=1)			// build Wo
			{	limas_Wo[zeroOne][an] = limas_input[*limas_NOW];
				if( limas_Wo[zeroOne][an]!='\\' && limas_Wo[zeroOne][an]!="'"[0] )
				{	*limas_NOW += 1;
				}
				else
				{	limas_Wo[zeroOne][an] = 0;
					break;
					an = 0;
				}
			}
			limas_Wo[zeroOne][an] = 0;
			limas_Wo_max[zeroOne] = an;
			wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("\\"[n0] !=0 && "\\"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("\\"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		int NOWtemp2;
		NOWtemp2 = *limas_NOW;
		if(limas_length-*limas_NOW > 0)
			limas_bo_max[zeroOne] = 1;
		else
			limas_bo_max[zeroOne] = 0;
		for(; wordL[zeroOne] == -1 && limas_bo_max[zeroOne]>=0; limas_bo_max[zeroOne]-=1)	// bo
		{	*limas_NOW = NOWtemp2;
			limas_bo[zeroOne] = 0;
			for(an=0; an<limas_bo_max[zeroOne]; an+=1)			// build bo
			{	limas_bo[zeroOne] = limas_input[*limas_NOW];
				if(1)
				{	*limas_NOW += 1;
				}
				else
				{	limas_bo[zeroOne] = 0;
					break;
					an = 0;
				}
			}
			limas_bo_max[zeroOne] = an;
			if( limas_bo[zeroOne]!=0 )
			{	wordL[zeroOne] = *limas_NOW-NOWtemp0;
			}
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 1;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n1=0;
		while("'"[n1] !=0 && "'"[n1]==(&(limas_input[*limas_NOW]))[n1])	// string
		{	n1+=1;
		}
		if("'"[n1]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n1;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 2;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X,limas_Wo[!zeroOne]);
	
		goto more;
	}
	else if(longest == 1 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, "\\");
		strcat(X, limas_bo[!zeroOne]);
	
		goto more;
	}
	else if(longest == 2 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		failStack.length=0;
		return true;
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "singleQuote");
	
	return false;
}


bool word(int* limas_NOW, char* limas_input, int limas_length, char* X)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	int an;
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int NOWtemp1;
		NOWtemp1 = *limas_NOW;
		limas_Wo_max[zeroOne] = limas_length-*limas_NOW;
		for(; wordL[zeroOne] == -1 && limas_Wo_max[zeroOne]>=0; limas_Wo_max[zeroOne]-=1)	// Wo
		{	*limas_NOW = NOWtemp1;
			for(an=0; an<limas_Wo_max[zeroOne]; an+=1)			// build Wo
			{	limas_Wo[zeroOne][an] = limas_input[*limas_NOW];
				if( '0' <=limas_Wo[zeroOne][an]&&limas_Wo[zeroOne][an]<= '9' )
				{	*limas_NOW += 1;
				}
				else
				{	limas_Wo[zeroOne][an] = 0;
					break;
					an = 0;
				}
			}
			limas_Wo[zeroOne][an] = 0;
			limas_Wo_max[zeroOne] = an;
			wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(X,limas_Wo[!zeroOne]);
	
	}
	else 
	{
		strcpy(X,"");
	
	}
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int NOWtemp1;
		NOWtemp1 = *limas_NOW;
		limas_Wo_max[zeroOne] = limas_length-*limas_NOW;
		for(; wordL[zeroOne] == -1 && limas_Wo_max[zeroOne]>=0; limas_Wo_max[zeroOne]-=1)	// Wo
		{	*limas_NOW = NOWtemp1;
			for(an=0; an<limas_Wo_max[zeroOne]; an+=1)			// build Wo
			{	limas_Wo[zeroOne][an] = limas_input[*limas_NOW];
				if( limas_Wo[zeroOne][an]=='_' || ('0' <=limas_Wo[zeroOne][an]&&limas_Wo[zeroOne][an]<= '9') || ('a' <=limas_Wo[zeroOne][an]&&limas_Wo[zeroOne][an]<= 'z') || ('A' <=limas_Wo[zeroOne][an]&&limas_Wo[zeroOne][an]<= 'Z'))
				{	*limas_NOW += 1;
				}
				else
				{	limas_Wo[zeroOne][an] = 0;
					break;
					an = 0;
				}
			}
			limas_Wo[zeroOne][an] = 0;
			limas_Wo_max[zeroOne] = an;
			if( limas_Wo[zeroOne][0]!=0 && (!allEQ(limas_Wo[zeroOne],"__") || X[0]!=0) )
			{	wordL[zeroOne] = *limas_NOW-NOWtemp0;
			}
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X,limas_Wo[!zeroOne]);
		failStack.length=0;
		return true;
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "word");
	
	return false;
}


bool theLanguage(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000], limas_theTop[2][20000], limas_theMid[2][20000];
	int limas_Wo_max[2], limas_theTop_max[2], limas_theMid_max[2];

	tempLabel=&&T0;
every:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		anychar_vars.length = 0; // make sure the main and crap crapBracket doesn't pick up anychars
			anycharString_vars.length = 0; // ..
		
	}
	else
		goto LIMAsEndOfParseFunction;
	goto *tempLabel;		//leave 'every' block and return to the main sequence

	tempLabel=&&T0;
	goto every;
T0:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while(""[n0] !=0 && ""[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if(""[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		main_already=false;
	
	}
	else
		goto LIMAsEndOfParseFunction;
top: //->
	tempLabel=&&T1;
	goto every;
T1:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("main"[n0] !=0 && "main"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("main"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!crapBracket(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne], true, false))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n1=0;
		while("glob"[n1] !=0 && "glob"[n1]==(&(limas_input[*limas_NOW]))[n1])	// string
		{	n1+=1;
		}
		if("glob"[n1]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n1;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!crapBracket(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne], true, false))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 1;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!theParse(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 2;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n2=0;
		while(""[n2] !=0 && ""[n2]==(&(limas_input[*limas_NOW]))[n2])	// string
		{	n2+=1;
		}
		if(""[n2]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n2;

		if((&(limas_input[*limas_NOW]))[0]==0)
		{	wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 3;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		if(main_already)
		{	printf("Only one main allowed sukka. Check block that ends on line %d. \n", theNewLines.getLine((int)(&(limas_input[*limas_NOW]))) );
			return false; //fail
		}
		strcat(output_middle,"main()\n");
		strcat(output_middle,"{");
		strcat(output_middle,limas_Wo[!zeroOne]);
		strcat(output_middle,"}\n\n");
		main_already=1;	// now main has been found and written already
	
		goto top;
	}
	else if(longest == 1 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(output_middle,limas_Wo[!zeroOne]);
		strcat(output_middle,"\n");
	
		goto top;
	}
	else if(longest == 2 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// got a parse function
	
		goto top;
	}
	else if(longest == 3 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(output_top,"\n\n");
		failStack.length=0;
		return true;// end
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "theLanguage");
	
	return false;
}


bool multiLine_C_Comment(int* limas_NOW, char* limas_input, int limas_length, char* X)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	int an;
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("/*"[n0] !=0 && "/*"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("/*"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(X, "/*");
	
	}
	else
		goto LIMAsEndOfParseFunction;
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int NOWtemp1;
		NOWtemp1 = *limas_NOW;
		limas_Wo_max[zeroOne] = limas_length-*limas_NOW;
		for(; wordL[zeroOne] == -1 && limas_Wo_max[zeroOne]>=0; limas_Wo_max[zeroOne]-=1)	// Wo
		{	*limas_NOW = NOWtemp1;
			for(an=0; an<limas_Wo_max[zeroOne]; an+=1)			// build Wo
			{	limas_Wo[zeroOne][an] = limas_input[*limas_NOW];
				if( limas_Wo[zeroOne][an]!='*' )
				{	*limas_NOW += 1;
				}
				else
				{	limas_Wo[zeroOne][an] = 0;
					break;
					an = 0;
				}
			}
			limas_Wo[zeroOne][an] = 0;
			limas_Wo_max[zeroOne] = an;
			wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, limas_Wo[!zeroOne]);
	
	}
	else
		goto LIMAsEndOfParseFunction;
more: //->
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("*/"[n0] !=0 && "*/"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("*/"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n1=0;
		while("*"[n1] !=0 && "*"[n1]==(&(limas_input[*limas_NOW]))[n1])	// string
		{	n1+=1;
		}
		if("*"[n1]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n1;

		int NOWtemp1;
		NOWtemp1 = *limas_NOW;
		limas_Wo_max[zeroOne] = limas_length-*limas_NOW;
		for(; wordL[zeroOne] == -1 && limas_Wo_max[zeroOne]>=0; limas_Wo_max[zeroOne]-=1)	// Wo
		{	*limas_NOW = NOWtemp1;
			for(an=0; an<limas_Wo_max[zeroOne]; an+=1)			// build Wo
			{	limas_Wo[zeroOne][an] = limas_input[*limas_NOW];
				if( limas_Wo[zeroOne][an]!='/' && limas_Wo[zeroOne][an]!='*' )
				{	*limas_NOW += 1;
				}
				else
				{	limas_Wo[zeroOne][an] = 0;
					break;
					an = 0;
				}
			}
			limas_Wo[zeroOne][an] = 0;
			limas_Wo_max[zeroOne] = an;
			wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 1;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// end of crap bracket
		strcat(X, "*/");
		failStack.length=0;
		return true;
	
	}
	else if(longest == 1 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, "*");
		strcat(X, limas_Wo[!zeroOne]);
	
		goto more;
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "multiLine_C_Comment");
	
	return false;
}


bool crapBracket(int* limas_NOW, char* limas_input, int limas_length, char* X, bool notzeroOne, bool now0)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	int an;
	char limas_ao[2];
	int limas_ao_max[2];
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("["[n0] !=0 && "["[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("["[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// the beggining of crap
			countparens = 1;
			strcpy(X, "");
		
	}
	else
		goto LIMAsEndOfParseFunction;
morecrap: //->
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int NOWtemp1;
		NOWtemp1 = *limas_NOW;
		limas_Wo_max[zeroOne] = limas_length-*limas_NOW;
		for(; wordL[zeroOne] == -1 && limas_Wo_max[zeroOne]>=0; limas_Wo_max[zeroOne]-=1)	// Wo
		{	*limas_NOW = NOWtemp1;
			for(an=0; an<limas_Wo_max[zeroOne]; an+=1)			// build Wo
			{	limas_Wo[zeroOne][an] = limas_input[*limas_NOW];
				if( limas_Wo[zeroOne][an]!='"' && limas_Wo[zeroOne][an]!='[' && limas_Wo[zeroOne][an]!=']' && !('a' <=limas_Wo[zeroOne][an]&&limas_Wo[zeroOne][an]<= 'z')  && !('A' <=limas_Wo[zeroOne][an]&&limas_Wo[zeroOne][an]<= 'Z') 
				&& limas_Wo[zeroOne][an]!='/' && limas_Wo[zeroOne][an]!='\'')
				{	*limas_NOW += 1;
				}
				else
				{	limas_Wo[zeroOne][an] = 0;
					break;
					an = 0;
				}
			}
			limas_Wo[zeroOne][an] = 0;
			limas_Wo_max[zeroOne] = an;
			if( limas_Wo[zeroOne][0]!=0 )
			{	wordL[zeroOne] = *limas_NOW-NOWtemp0;
			}
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("//"[n0] !=0 && "//"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("//"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		int NOWtemp2;
		NOWtemp2 = *limas_NOW;
		limas_Wo_max[zeroOne] = limas_length-*limas_NOW;
		for(; wordL[zeroOne] == -1 && limas_Wo_max[zeroOne]>=0; limas_Wo_max[zeroOne]-=1)	// Wo
		{	*limas_NOW = NOWtemp2;
			for(an=0; an<limas_Wo_max[zeroOne]; an+=1)			// build Wo
			{	limas_Wo[zeroOne][an] = limas_input[*limas_NOW];
				if( limas_Wo[zeroOne][an]!='\n' )
				{	*limas_NOW += 1;
				}
				else
				{	limas_Wo[zeroOne][an] = 0;
					break;
					an = 0;
				}
			}
			limas_Wo[zeroOne][an] = 0;
			limas_Wo_max[zeroOne] = an;
			int n1=0;
			while("\n"[n1] !=0 && "\n"[n1]==(&(limas_input[*limas_NOW]))[n1])	// string
			{	n1+=1;
			}
			if("\n"[n1]!=0)
			{	continue;	// string didn't match
			}
			*limas_NOW += n1;

			wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 1;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!multiLine_C_Comment(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 2;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n2=0;
		while("/"[n2] !=0 && "/"[n2]==(&(limas_input[*limas_NOW]))[n2])	// string
		{	n2+=1;
		}
		if("/"[n2]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n2;

		int NOWtemp3;
		NOWtemp3 = *limas_NOW;
		if(limas_length-*limas_NOW > 0)
			limas_ao_max[zeroOne] = 1;
		else
			limas_ao_max[zeroOne] = 0;
		for(; wordL[zeroOne] == -1 && limas_ao_max[zeroOne]>=0; limas_ao_max[zeroOne]-=1)	// ao
		{	*limas_NOW = NOWtemp3;
			limas_ao[zeroOne] = 0;
			for(an=0; an<limas_ao_max[zeroOne]; an+=1)			// build ao
			{	limas_ao[zeroOne] = limas_input[*limas_NOW];
				if( limas_ao[zeroOne]!="/"[0] && limas_ao[zeroOne]!='*' )
				{	*limas_NOW += 1;
				}
				else
				{	limas_ao[zeroOne] = 0;
					break;
					an = 0;
				}
			}
			limas_ao_max[zeroOne] = an;
			wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 3;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 4;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n3=0;
		while("["[n3] !=0 && "["[n3]==(&(limas_input[*limas_NOW]))[n3])	// string
		{	n3+=1;
		}
		if("["[n3]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n3;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 5;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n4=0;
		while("]"[n4] !=0 && "]"[n4]==(&(limas_input[*limas_NOW]))[n4])	// string
		{	n4+=1;
		}
		if("]"[n4]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n4;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 6;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!quote(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 7;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!singleQuote(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 8;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, limas_Wo[!zeroOne]);
		
		goto morecrap;
	}
	else if(longest == 1 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, "//");
			strcat(X, limas_Wo[!zeroOne]);
			strcat(X, "\n");
			
			theNewLines.add( ((int)(&(limas_input[*limas_NOW])))-1);
		
		goto morecrap;
	}
	else if(longest == 2 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, limas_Wo[!zeroOne]);
		
		goto morecrap;
	}
	else if(longest == 3 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, "/");
			strcat(X, limas_ao[!zeroOne]);
		
		goto morecrap;
	}
	else if(longest == 4 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		transformIfAnychar(limas_Wo[!zeroOne], notzeroOne, now0);
			strcat(X, limas_Wo[!zeroOne]);
		
		goto morecrap;
	}
	else if(longest == 5 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, "[");
			countparens++;
		
		goto crap1;
	}
	else if(longest == 6 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		countparens--;
			if(countparens!=0)
			{	strcat(X, "]");
			}
		
		goto crap1;
	}
	else if(longest == 7 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, "\"");
			strcat(X, limas_Wo[!zeroOne]);
			strcat(X, "\"");
		
		goto morecrap;
	}
	else if(longest == 8 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(X, "'");
			strcat(X, limas_Wo[!zeroOne]);
			strcat(X, "'");
		
		goto morecrap;
	}
	else 
	{
		(&(limas_input[*limas_NOW]))[10] = 0;
			printf("BAD input between brackets on line %d: '%s'\n", theNewLines.getLine((int)(&(limas_input[*limas_NOW]))) );
			return false;
		
	}
crap1: //->
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while(""[n0] !=0 && ""[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if(""[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(countparens==0)
		{	wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		//;; tests if it found the end crap bracket
			failStack.length=0;
			return true;
		
	}
	else 
	{
	
		
		goto morecrap;
	}
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "crapBracket");
	
	return false;
}


bool theParse(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	tempLabel=&&T0;
every:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// do nothing
	
	}
	else
		goto LIMAsEndOfParseFunction;
	goto *tempLabel;		//leave 'every' block and return to the main sequence

	tempLabel=&&T0;
	goto every;
T0:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("parse"[n0] !=0 && "parse"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("parse"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// the name of the parse function
		strcat(output_middle, "bool ");
		strcat(output_middle, limas_Wo[!zeroOne]);
		strcat(output_middle, "(int* limas_NOW, char* limas_input, int limas_length");
		
		strcat(output_top, "bool ");
		strcat(output_top, limas_Wo[!zeroOne]);
		strcat(output_top, "(int* limas_NOW, char* limas_input, int limas_length");
		
		CI=0;
		in_every = false;
		in_tween = false;
		tweenExists = false;
		everyExists=false;
		notween=false;
	
	}
	else
		goto LIMAsEndOfParseFunction;
	tempLabel=&&T1;
	goto every;
T1:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("["[n0] !=0 && "["[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("["[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!outputs(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		anychar_vars.length=0;
		anycharString_vars.length=0;
		strcpy(anyN, "");
		
		if(limas_Wo[!zeroOne][0]!=0)	// if there are some other arguments
		{	strcat(output_middle, ", ");
			strcat(output_middle, limas_Wo[!zeroOne]);
			
			strcat(output_top, ", ");
			strcat(output_top, limas_Wo[!zeroOne]);
		}
		strcat(output_middle, ")\n");
		strcat(output_middle, "{");
			
		strcat(output_top, ");\n");
		
			CI += 1;
			
			strcat(output_middle, "	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested\n");
				strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "void* tempLabel;		// holds the value of a return label\n");
				strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "int zeroOne=0;			// holds which anychars set should be overwritten\n");
				strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "int longest;			// holds the index of the longest wordform (used for choosing which actions to do)\n");
				strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "int countparens;		// makes sure brackets are properly matched\n");
				strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "int diffTemp;			// records the diff from a function\n");
				strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "int NOWtemp0;			// records the current stable position (CURpos)\n");
				strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "*limas_NOW=0;				// NOW should start as being 0\n");

	
	}
	else
		goto LIMAsEndOfParseFunction;
moreAnychar_s: //->
	tempLabel=&&T2;
	goto every;
T2:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!anychars(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!anycharStrings(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 1;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("anyindex"[n0] !=0 && "anyindex"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("anyindex"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 2;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
				
		goto moreAnychar_s;
	}
	else if(longest == 1 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
				
		goto moreAnychar_s;
	}
	else if(longest == 2 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		if(anyN[0]!=0)
		{	printf("Second 'anyindex' variable defined on line %d. You only need one 'anyindex' variable. More aren't permitted.\n", theNewLines.getLine((int)(&(limas_input[*limas_NOW]))) );
			return false;
		}
		else
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "int ");
			strcat(output_middle, limas_Wo[!zeroOne]);
			strcat(output_middle, ";\n");
			
			strcpy(anyN, limas_Wo[!zeroOne]);
		}
	
		goto moreAnychar_s;
	}
	else 
	{
		// done getting anychars
		if(anychar_vars.length >0)
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
				strcat(output_middle, "char ");
				
			for(int anycharN=0; anycharN<anychar_vars.length; anycharN++)
			{	strcat(output_middle, "limas_");
					strcat(output_middle, anychar_vars[anycharN]);
					strcat(output_middle, "[2]");
				if(anycharN+1<anychar_vars.length)
				{	strcat(output_middle, ", ");
				}
				else
				{	strcat(output_middle, ";\n");
				}
			}
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
				strcat(output_middle, "int ");
			
			for(int anycharN=0; anycharN<anychar_vars.length; anycharN++)
			{	strcat(output_middle, "limas_");
					strcat(output_middle, anychar_vars[anycharN]);
					strcat(output_middle, "_max[2]");
				if(anycharN+1<anychar_vars.length)
				{	strcat(output_middle, ", ");
				}
				else
				{	strcat(output_middle, ";\n");
				}
			}
		}
		
		if(anycharString_vars.length >0)
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
				strcat(output_middle, "char ");
				
			for(int anycharN=0; anycharN<anycharString_vars.length; anycharN++)
			{	strcat(output_middle, "limas_");
					strcat(output_middle, anycharString_vars[anycharN]);
					strcat(output_middle, "[2][20000]");
				if(anycharN+1<anycharString_vars.length)
				{	strcat(output_middle, ", ");
				}
				else
				{	strcat(output_middle, ";\n");
				}
			}
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
				strcat(output_middle, "int ");
			
			for(int anycharN=0; anycharN<anycharString_vars.length; anycharN++)
			{	strcat(output_middle, "limas_");
					strcat(output_middle, anycharString_vars[anycharN]);
					strcat(output_middle, "_max[2]");
				if(anycharN+1<anycharString_vars.length)
				{	strcat(output_middle, ", ");
				}
				else
				{	strcat(output_middle, ";\n");
				}
			}
		}
		
		strcat(output_middle, "\n");
	
	}
	tempLabel=&&T3;
	goto every;
T3:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("top"[n0] !=0 && "top"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("top"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!crapBracket(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne], false, false))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcat(output_middle, "\n");
	
		strcat(output_middle, limas_Wo[!zeroOne]);
		
		strcat(output_middle, "\n");
	
	}
	else 
	{
		// continue
	
	}
	tempLabel=&&T4;
	goto every;
T4:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("onfail"[n0] !=0 && "onfail"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("onfail"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!crapBracket(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne], false, true))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(onFailBlock, limas_Wo[!zeroOne]);
	
	}
	else 
	{
		strcpy(onFailBlock, "");
	
	}
	tempLabel=&&T5;
	goto every;
T5:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("onmismatch"[n0] !=0 && "onmismatch"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("onmismatch"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!crapBracket(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne], false, true))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(onMismatchBlock, limas_Wo[!zeroOne]);
	
	}
	else 
	{
		strcpy(onMismatchBlock, "");
	
	}
	tempLabel=&&T6;
	goto every;
T6:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!alwaysAndBetween(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		choiceSetNumber=0;
	
	}
	else
		goto LIMAsEndOfParseFunction;
newChoicesSet: //->
	tempLabel=&&T7;
	goto every;
T7:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!wordformChoice(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
			
		goto newChoicesSet;
	}
	else 
	{
		// the end is near
	
	}
	tempLabel=&&T8;
	goto every;
T8:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("]"[n0] !=0 && "]"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("]"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// end of parse
		strcat(output_middle, "LIMAsEndOfParseFunction:	\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, onFailBlock);
		
		strcat(output_middle, "\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "return false;\n");
		
		CI -=1;
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "}\n\n\n");
		
		failStack.length=0;
		return true;
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "theParse");
	
	return false;
}


bool outputs(int* limas_NOW, char* limas_input, int limas_length, char* X)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("in"[n0] !=0 && "in"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("in"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!crapBracket(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, X, false, false))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// inputs (for example: "in[char* b, int n, whatever g]:" )
		failStack.length=0;
		return true;
	
	}
	else 
	{
		strcpy(X, "");
		failStack.length=0;
		return true;
	
	}
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "outputs");
	
	return false;
}


bool anychars(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("anychar"[n0] !=0 && "anychar"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("anychar"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
				
	}
	else
		goto LIMAsEndOfParseFunction;
anAnychar: //->
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(anychar_vars[anychar_vars.length], limas_Wo[!zeroOne]);
	
	}
	else
		goto LIMAsEndOfParseFunction;
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		int n0=0;
		while(","[n0] !=0 && ","[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if(","[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
				
		goto anAnychar;
	}
	else 
	{
		failStack.length=0;
		return true;
	
	}
LIMAsEndOfParseFunction:	
		outputFail((&(limas_input[NOWtemp0])), "anychars");
	
	return false;
}


bool anycharStrings(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("anychar"[n0] !=0 && "anychar"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("anychar"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		int n1=0;
		while("["[n1] !=0 && "["[n1]==(&(limas_input[*limas_NOW]))[n1])	// string
		{	n1+=1;
		}
		if("["[n1]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n1;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		int n2=0;
		while("]"[n2] !=0 && "]"[n2]==(&(limas_input[*limas_NOW]))[n2])	// string
		{	n2+=1;
		}
		if("]"[n2]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n2;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
				
	}
	else
		goto LIMAsEndOfParseFunction;
anAnychar: //->
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(anycharString_vars[anycharString_vars.length], limas_Wo[!zeroOne]);
	
	}
	else
		goto LIMAsEndOfParseFunction;
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		int n0=0;
		while(","[n0] !=0 && ","[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if(","[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
				
		goto anAnychar;
	}
	else 
	{
		failStack.length=0;
		return true;
	
	}
LIMAsEndOfParseFunction:	
		outputFail((&(limas_input[NOWtemp0])), "anycharStrings");
	
	return false;
}


	bool everyHandling()
	{	if(everyExists)
		{	printf("You can only have one 'every' block. Please fix your parse function.\n");
			return false;
		}
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "tempLabel=&&T0;\n");
		
		strcat(output_middle, "every:\n");
		in_every = true;
		everyExists=true;
		
		setupForChoices();
	}

bool alwaysAndBetween(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_ao[2];
	int limas_ao_max[2];
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	tempLabel=&&T0;
every:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
			
	}
	else
		goto LIMAsEndOfParseFunction;
	goto *tempLabel;		//leave 'every' block and return to the main sequence

	tempLabel=&&T0;
	goto every;
T0:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("every"[n0] !=0 && "every"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("every"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// replacement for the "always" keyword - performed before every bracket of choices
		everyHandling();
	
	}
	else 
	{
		everyExists=false;	// every must go first
	
		goto toTween;
	}
	tempLabel=&&T1;
	goto every;
T1:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!setOfChoices(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		cleanUpAfterChoices();
		// continue after choices
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle,"goto *tempLabel;		//leave 'every' block and return to the main sequence\n\n");
		in_every = false;
		in_tween = false;
	
	}
	else
		goto LIMAsEndOfParseFunction;
toTween: //->
	tempLabel=&&T2;
	goto every;
T2:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("tween"[n0] !=0 && "tween"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("tween"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// something that is run between every word inside the wordform (eg. with ws[] being the tween, (a b c) would be the same as (a ws[] b ws[] c)
		tweenExists = true;
	
	}
	else 
	{
				
		goto afterTween;
	}
	tempLabel=&&T3;
	goto every;
T3:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!wordform(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		tweenOrder.length=0;
		for(int n=0; n<theOrder.length; n++)
		{	strcpy(tweenOrder[n], theOrder[n]);
		}
	
		in_tween = false;
	
	}
	else
		goto LIMAsEndOfParseFunction;
	tempLabel=&&T4;
	goto every;
T4:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("["[n0] !=0 && "["[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("["[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
				
	}
	else
		goto LIMAsEndOfParseFunction;
	tempLabel=&&T5;
	goto every;
T5:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("]"[n0] !=0 && "]"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("]"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
				
	}
	else 
	{
		printf("I'm sorry, tween doesn't support having actions inside its action bracket. Maybe in the next version : )\n");
		return false;
	
	}
afterTween: //->
	tempLabel=&&T6;
	goto every;
T6:
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("every"[n0] !=0 && "every"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("every"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		printf("The 'every' block must come before the 'tween' block. ");
		if(everyExists)
		{	printf("You can only have one 'every' block anyways, come on man. ");
		}
		printf("Please fix your parse function.Check line %d.\n", theNewLines.getLine((int)(&(limas_input[*limas_NOW]))) );
		return false;
	
	}
	else 
	{
		failStack.length=0;
		return true;	// returns true even if neither every nor tween were found.
	
	}
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "alwaysAndBetween");
	
	return false;
}


bool wordformChoice(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!arrow(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		if(limas_Wo[!zeroOne][0]!=0)
		{	strcat(output_middle, limas_Wo[!zeroOne]);
			strcat(output_middle, ": //->\n");
		}
	
	}
	else
		goto LIMAsEndOfParseFunction;
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		int n0=0;
		while("noevery"[n0] !=0 && "noevery"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("noevery"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		noevery=true;
		setupForChoices();
	
	}
	else 
	{
		noevery=false;
		setupForChoices();
	
	}
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!setOfChoices(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		cleanUpAfterChoices();
		failStack.length=0;
		return true;
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "wordformChoice");
	
	return false;
}


bool setOfChoices(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

choices: //->
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!choice(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
				
		goto choices;
	}
	else 
	{
		failStack.length=0;
		return true;
	
	}
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "setOfChoices");
	
	return false;
}


bool arrow(int* limas_NOW, char* limas_input, int limas_length,  char* X)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("->"[n0] !=0 && "->"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("->"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		int n1=0;
		while("->"[n1] !=0 && "->"[n1]==(&(limas_input[*limas_NOW]))[n1])	// string
		{	n1+=1;
		}
		if("->"[n1]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n1;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 1;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(X,"");	// no label
		failStack.length=0;
		return true;
	
	}
	else if(longest == 1 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(X,limas_Wo[!zeroOne]);
		failStack.length=0;
		return true;
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "arrow");
	
	return false;
}


bool choice(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("notween"[n0] !=0 && "notween"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("notween"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		notween=true;
		if(in_tween)
		{	printf("'tween' wordforms can't have a 'notween' designation as they are implicitly 'notween'. Check line %d.\n", theNewLines.getLine((int)(&(limas_input[*limas_NOW]))) );
			return false;
		}
		else if(in_every)
		{	printf("'every' wordforms can't have a 'notween' designation as they are implicitly 'notween'. Check line %d.\n", theNewLines.getLine((int)(&(limas_input[*limas_NOW]))) );
			return false;
		}
	
	}
	else 
	{
		
	
	}
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!wordform(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
			
	}
	else
		goto LIMAsEndOfParseFunction;
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!conditional(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// write the conditional if statement, close all outstanding parens, Save actions for later, set up for next wordform
			
		if(!in_else)
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			if(limas_Wo[!zeroOne][0]!=0)
			{	strcat(output_middle, "if(");
				strcat(output_middle, limas_Wo[!zeroOne]);
				strcat(output_middle, ")\n");
				
				strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
				strcat(output_middle, "{	");
			}
			strcat(output_middle, "wordL[zeroOne] = *limas_NOW-NOWtemp0;\n");
			
			if(limas_Wo[!zeroOne][0]!=0)
			{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
				strcat(output_middle, "}\n");
			}
		
			for(int n=0; n<forNum; n++)
			{	CI -= 1;
				strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
				strcat(output_middle, "}\n");
			}
		
			CI -= 1;
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "} while(0);\n");
		
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "if(wordL[!zeroOne] < wordL[zeroOne])\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "{	longest = ");
			strcat(output_middle, itS(wordformNumber, sMultTemp));
			strcat(output_middle, ";\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "	zeroOne=!zeroOne;\n");
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "}\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "else\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "{	");
			strcat(output_middle, onMismatchBlock);
			strcat(output_middle, "}\n\n");
		}
	
	
	}
	else
		goto LIMAsEndOfParseFunction;
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!crapBracket(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne], true, false))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(theActions[wordformNumber], limas_Wo[!zeroOne]);
		if(in_else)
		{	elseNumber = wordformNumber;
		}
	
	}
	else
		goto LIMAsEndOfParseFunction;
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		int n0=0;
		while(">"[n0] !=0 && ">"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if(">"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
			
	}
	else 
	{
		strcpy(theLabel[wordformNumber], "");
		
		wordformNumber += 1;
		failStack.length=0;
		return true;// no label
	
	}
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(theLabel[wordformNumber], limas_Wo[!zeroOne]);
	
		wordformNumber += 1;
		failStack.length=0;
		return true;
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "choice");
	
	return false;
}


bool wordform(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!arrow(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		return false;	// don't get confused by a labeled arrow
	
	}
	else 
	{
		// move on
	
	}
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!quote(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if( strcmp(limas_Wo[zeroOne],"tween") && strcmp(limas_Wo[zeroOne],"else") )
		{	wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 1;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!function(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 2;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!multiForm(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 3;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("else"[n0] !=0 && "else"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("else"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 4;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		char aString[100];
		strcpy(aString, "Q\"");
		strcat(aString, limas_Wo[!zeroOne]);
		strcat(aString, "\"");
	
		strcpy(theOrder[0], aString);
		theOrder.length=1;
	
	}
	else if(longest == 1 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		char aString[100];
		strcpy(aString, "W");
		strcat(aString, limas_Wo[!zeroOne]);
	
		strcpy(theOrder[0], aString);
		theOrder.length=1;
	
	}
	else if(longest == 2 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		char aString[100];
		strcpy(aString, "F");
		strcat(aString, limas_Wo[!zeroOne]);
	
		strcpy(theOrder[0], aString);
		theOrder.length=1;
	
	}
	else if(longest == 3 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
			
	}
	else if(longest == 4 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		in_else=true;
		theOrder.length=0;
	
	}
	else
		goto LIMAsEndOfParseFunction;
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while(""[n0] !=0 && ""[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if(""[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		failStack.length=0;
		return true; // for all 5 types
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "wordform");
	
	return false;
}


bool conditional(int* limas_NOW, char* limas_input, int limas_length, char* X)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000], limas_Xo[2][20000];
	int limas_Wo_max[2], limas_Xo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while(""[n0] !=0 && ""[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if(""[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(X,"");
		buildBlocks.length=0;
	
	}
	else
		goto LIMAsEndOfParseFunction;
more: //->
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		int n0=0;
		while("cond"[n0] !=0 && "cond"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("cond"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!crapBracket(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Xo[zeroOne], 0, false))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!crapBracket(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Xo[zeroOne], 0, false))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 1;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// conditions
		if(in_else)
		{	printf("An 'else' can't have a condition block, please fix your parse function. Check the condition block that ends on line %d.\n", theNewLines.getLine((int)(&(limas_input[*limas_NOW]))) );
			return false;
		}
		if(X[0]!=0)
		{	printf("There can be only one 'cond' block, please fix your parse function. Check the condition block that ends on line %d.\n", theNewLines.getLine((int)(&(limas_input[*limas_NOW]))) );
			return false;
		}
		strcpy(X, limas_Xo[!zeroOne]);
	
		goto more;
	}
	else if(longest == 1 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		if(in_else)
		{	printf("An 'else' can't have anychar build blocks. Check the block that ends on line %d.\n", theNewLines.getLine((int)(&(limas_input[*limas_NOW]))) );//, please use the 'cond' block for else conditions\n);
			return false;
		}
		if(isAnycharString(limas_Wo[!zeroOne]) || isAnychar(limas_Wo[!zeroOne]))
		{	int temp=buildBlocks.length;
			strcpy(buildBlocks[temp][0], limas_Wo[!zeroOne]);
			strcpy(buildBlocks[temp][1], limas_Xo[!zeroOne]);
		}
		else
		{	printf("You have a build block for a non-existant anychar variable: '%s'. Check the block that ends on line %d.\n", limas_Wo[!zeroOne], theNewLines.getLine((int)(&(limas_input[*limas_NOW]))) );//, please use the 'cond' block for else conditions\n);
			return false;
		}
	
		goto more;
	}
	else 
	{
		// should have found beggining of action bracket
		if(!in_else)
		{	setupForWordform();
		}
		
		for(int n=0; n<theOrder.length; n++)
		{	if(theOrder[n][0] == 'Q')
			{	handleString(&(theOrder[n][1]));
			}
			else if(theOrder[n][0] == 'W')
			{	int r;
				for(r=0; r<buildBlocks.length; r++)		// find the build block for the current anychar or anychar[] 
				{	if(!strcmp(&(theOrder[n][1]), buildBlocks[r][0]))
					{	break;
					}
				}
				
				if(r!=buildBlocks.length)	// if a build block has been found for this anychar
				{	handleWord(&(theOrder[n][1]), buildBlocks[r][1]);
				}
				else
				{	handleWord(&(theOrder[n][1]), 0);
				}
			}
			else if(theOrder[n][0] == 'F')
			{	handleFunction(&(theOrder[n][1]));
			}
			
			if(!notween && tweenExists && n+1<theOrder.length)
			{	for(int mnm=0; mnm<tweenOrder.length; mnm++)
				{	if(tweenOrder[mnm][0] == 'Q')
					{	handleString(&(tweenOrder[mnm][1]));
					}
					else if(tweenOrder[mnm][0] == 'W')
					{	handleWord(&(tweenOrder[mnm][1]), 0);
					}
					else if(tweenOrder[mnm][0] == 'F')
					{	handleFunction(&(tweenOrder[mnm][1]));
					}
				}
			}
		}
		failStack.length=0;
		return true;
	
	}
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "conditional");
	
	return false;
}


bool multiForm(int* limas_NOW, char* limas_input, int limas_length)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000];
	int limas_Wo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		int n0=0;
		while("("[n0] !=0 && "("[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if("("[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		theOrder.length=0;
	
	}
	else
		goto LIMAsEndOfParseFunction;
more: //->
	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!quote(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 1;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!function(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 2;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	do
	{	*limas_NOW = NOWtemp0;
		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		int n0=0;
		while(")"[n0] !=0 && ")"[n0]==(&(limas_input[*limas_NOW]))[n0])	// string
		{	n0+=1;
		}
		if(")"[n0]!=0)
		{	continue;	// string didn't match
		}
		*limas_NOW += n0;

		wordL[zeroOne] = *limas_NOW-NOWtemp0;
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 3;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		char aString[100];
		strcpy(aString, "Q\"");
		strcat(aString, limas_Wo[!zeroOne]);
		strcat(aString, "\"");
	
		strcpy(theOrder[theOrder.length], aString);
	
		goto more;
	}
	else if(longest == 1 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		// keep in mind this word can be a parameterless function
		char aString[100];
		strcpy(aString, "W");
		strcat(aString, limas_Wo[!zeroOne]);
		strcpy(theOrder[theOrder.length], aString);
	
		goto more;
	}
	else if(longest == 2 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		char aString[100];
		strcpy(aString, "F");
		strcat(aString, limas_Wo[!zeroOne]);
		strcpy(theOrder[theOrder.length], aString);
	
		goto more;
	}
	else if(longest == 3 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		failStack.length=0;
		return true;
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "multiForm");
	
	return false;
}


bool function(int* limas_NOW, char* limas_input, int limas_length, char* X)
{	int wordL[2];		// holds the lengths of the current longest wordform, and the wordform being currently tested
	void* tempLabel;		// holds the value of a return label
	int zeroOne=0;			// holds which anychars set should be overwritten
	int longest;			// holds the index of the longest wordform (used for choosing which actions to do)
	int countparens;		// makes sure brackets are properly matched
	int diffTemp;			// records the diff from a function
	int NOWtemp0;			// records the current stable position (CURpos)
	*limas_NOW=0;				// NOW should start as being 0
	char limas_Wo[2][20000], limas_Xo[2][20000];
	int limas_Wo_max[2], limas_Xo_max[2];

	wordL[zeroOne]=-1;
	wordL[!zeroOne]=-1;
	NOWtemp0 = *limas_NOW;
	do
	{	*limas_NOW = NOWtemp0;
		if(!word(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Wo[zeroOne]))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!ws(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if(!crapBracket(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW, limas_Xo[zeroOne], false, false))
		{	continue;	// function didn't match
		}
		*limas_NOW+=diffTemp;

		if( strcmp(limas_Wo[zeroOne], "else") )
		{	wordL[zeroOne] = *limas_NOW-NOWtemp0;
		}
	} while(0);
	if(wordL[!zeroOne] < wordL[zeroOne])
	{	longest = 0;
		zeroOne=!zeroOne;
	}
	else
	{		if(debug)
			choiceMismatch((&(limas_input[NOWtemp0])));
	}

	if(longest == 0 && wordL[!zeroOne] > -1)
	{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];
		strcpy(X,limas_Wo[!zeroOne]);
		strcat(X, "(&diffTemp, &(limas_input[*limas_NOW]), limas_length-*limas_NOW");
		if(limas_Xo[!zeroOne][0]!=0)
		{	strcat(X, ", ");
			strcat(X, limas_Xo[!zeroOne]);
		}
		strcat(X, ")");
		failStack.length=0;
		return true;
	
	}
	else
		goto LIMAsEndOfParseFunction;
LIMAsEndOfParseFunction:	
		if(debug)
			outputFail((&(limas_input[NOWtemp0])), "function");
	
	return false;
}


	////////////////////////////////////////////////////////////////////////////////////
	
	int SL(char x)
	{   if(x==0)
	        return 0;
	    else
	        return 1;
	}
	
	int SL(char* x)
	{   int n=0;
	    while(x[n]!=0)
	    	n++;
	    
	    return n;
	}
	
	// creates out from a and b. a and b should be same length, and a[0] should correspond to b[0] etc.
	char* twoDLiteralString(char* a, char* b, char out[][2])
	{	for(int n=0; a[n]!=0; n++)
		{	out[n][0]=a[n];
			out[n][1]=b[n];
		}
		return (char*)out;
	}
	
	int testallEQ(char* a, char* equals)
	{	int n=0, m, set;
		int Length = SL(a);
	
		while(n<Length)
		{	set=0;
			for(m=0; equals[m]!=0; m++)
			{	if(a[n]==equals[m])
				{	set=1;
					break;
				}
			}
			if(set==0)
				return 0;
			n++;
		}
		return 1;	
	}
	
	int testallNEQ(char* a, char Nequals)
	{	for(int n=0; a[n]!=0; n++)
		{	if(a[n] == Nequals)
				return 0;
		}
		return 1;
	}
	
	int testallNEQ(char* a, char between1, char between2)
	{	for(int n=0; a[n]!=0; n++)
		{	if(a[n] <= between1 || between2 <= a[n])
				return 0;
		}
		return 1;
	}
	
	void strcpy(BDArr<char>& inThis, char* putThis)
	{	int m;
		inThis.length=0;
		for(m=0; putThis[m]!=0; m++)
		{	inThis[m] = putThis[m];
		}
	}
	
	void strcat(BDArr<char>& atEndOfThis, BDArr<char>& putThis)
	{	int m;
		for(m=0; m < putThis.length; m++)
		{	atEndOfThis[atEndOfThis.len()] = putThis[m];
		}
	}
	
	// special strcat for dynamicarray<char>
	void strcat(BDArr<char>& atEndOfThis, char* putThis)
	{	int m;
		for(m=0; putThis[m]!=0; m++)
		{	atEndOfThis[atEndOfThis.len()] = putThis[m];
		}
	}
	
	// special strcat for dynamicarray<char>
	void strcat(BDArr<char>& atEndOfThis, char* putThis, int dumdum)
	{	int m;
		for(m=0; putThis[m]!=0; m++)
		{	atEndOfThis[atEndOfThis.len()] = putThis[m];
		}
	}
	
	void strcat(BDArr<char>& atEndOfThis, char putThis)
	{	if(putThis!=0)
		{	atEndOfThis[atEndOfThis.len()] = putThis;
		}
	}
	
	void strcat(BDArr<char>& atEndOfThis, char putThis,  int dumdum)
	{	if(putThis!=0)
		{	atEndOfThis[atEndOfThis.len()] = putThis;
		}
	}
	
	bool isAnychar(char* in)
	{	for(int n=0; n < anychar_vars.length; n++)
		{	if(!strcmp(anychar_vars[n], in))
			{	return true;
			}
		}
		return false;
	}
	bool isAnycharString(char* in)
	{	for(int n=0; n < anycharString_vars.length; n++)
		{	if(!strcmp(anycharString_vars[n], in))
			{	return true;
			}
		}
		return false;
	}

	char* transformIfAnychar(char* in, bool notZeroOne, bool now0)
	{	if(isAnychar(in))
		{	char swapTemp[50];
			strcpy(swapTemp, in);
		
			strcpy(in, "limas_");
			strcat(in, swapTemp);
			strcat(in, "[");
			if(notZeroOne)
			{	strcat(in, "!");
			}
			strcat(in, "zeroOne]");
			return in;
		}
		if(isAnycharString(in))
		{	char swapTemp[50];
			strcpy(swapTemp, in);
		
			strcpy(in, "limas_");
			strcat(in, swapTemp);
			strcat(in, "[");
			if(notZeroOne)
			{	strcat(in, "!");
			}
			strcat(in, "zeroOne]");
			return in;
		}
		if(!strcmp("now", in))
		{	if(now0)
				strcpy(in, "(&(limas_input[NOWtemp0]))");
			else
				strcpy(in, "(&(limas_input[*limas_NOW]))");
				
			return in;
		}
		//else (if not an anychar or anychar[]
		return in;
	}
	
	
	
	
	
	// handles both anychar type words, and non-anychars (like regular variables, used basically like a quote is used)
	void handleString(char* string)
	{	char nNumber_temp[10];
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "int n");
		strcat(output_middle, itS(nNumber, nNumber_temp));
		strcat(output_middle, "=0;\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "while(");
		strcat(output_middle, string);
		strcat(output_middle, "[n");
		strcat(output_middle, nNumber_temp);
		strcat(output_middle, "] !=0 && ");
		strcat(output_middle, string);
		strcat(output_middle, "[n");
		strcat(output_middle, nNumber_temp);
		strcat(output_middle, "]==(&(limas_input[*limas_NOW]))[n");
		strcat(output_middle, nNumber_temp);
		strcat(output_middle, "])	// string\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "{\tn");
		strcat(output_middle, nNumber_temp);
		strcat(output_middle, "+=1;\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "}\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "if(");
		strcat(output_middle, string);
		strcat(output_middle, "[n");
		strcat(output_middle, nNumber_temp);
		strcat(output_middle, "]!=0)\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "{\tcontinue;	// string didn't match\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "}\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "*limas_NOW += n");
		strcat(output_middle, nNumber_temp);
		strcat(output_middle, ";\n\n");
		
		nNumber+=1;
	}
	
	void handleAnychar(char* word, char* buildBlock, bool isAnycharString)
	{	if(NOWtempNumbersDeclared<NOWtempNumber)
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "int NOWtemp");
			strcat(output_middle, itS(NOWtempNumber, sMultTemp));
			strcat(output_middle, ";\n");
			NOWtempNumbersDeclared += 1;
		}
			
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "NOWtemp");
		strcat(output_middle, itS(NOWtempNumber, sMultTemp));
		strcat(output_middle, " = *limas_NOW;\n");
		
		if(isAnycharString)
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "limas_");
			strcat(output_middle, word);
			strcat(output_middle, "_max[zeroOne] = limas_length-*limas_NOW;\n");
		}
		else 
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "if(limas_length-*limas_NOW > 0)\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "	limas_");
			strcat(output_middle, word);
			strcat(output_middle, "_max[zeroOne] = 1;\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "else\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "	limas_");
			strcat(output_middle, word);
			strcat(output_middle, "_max[zeroOne] = 0;\n");
		}
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "for(; wordL[zeroOne] == -1 && limas_");
		strcat(output_middle, word);
		strcat(output_middle, "_max[zeroOne]>=0; limas_");
		strcat(output_middle, word);
		strcat(output_middle, "_max[zeroOne]-=1)	// ");
		strcat(output_middle, word);
		strcat(output_middle, "\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "{\t*limas_NOW = NOWtemp");
		strcat(output_middle, itS(NOWtempNumber, sMultTemp));
		strcat(output_middle, ";\n");
		
		CI += 1;
		NOWtempNumber += 1;
		
		char anyIndexVariableTemp[50];
		
		if(anyN[0]==0)	// if there is no declared anyindex variable
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "int buildN;\n");
			
			strcpy(anyIndexVariableTemp, "buildN");
		}
		else
		{	strcpy(anyIndexVariableTemp, anyN);
		}
		
		
		if(isAnycharString == false)
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "limas_");
			strcat(output_middle, word);
			strcat(output_middle, "[zeroOne] = 0;\n");
		}
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "for(");
		strcat(output_middle, anyIndexVariableTemp);
		strcat(output_middle, "=0; ");
		strcat(output_middle, anyIndexVariableTemp);
		strcat(output_middle, "<limas_");
		strcat(output_middle, word);
		strcat(output_middle, "_max[zeroOne]; ");
		strcat(output_middle, anyIndexVariableTemp);
		strcat(output_middle, "+=1)			// build ");
		strcat(output_middle, word);
		strcat(output_middle, "\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "{	limas_");
		strcat(output_middle, word);
		strcat(output_middle, "[zeroOne]");
		if(isAnycharString)
		{	strcat(output_middle, "[");
			strcat(output_middle, anyIndexVariableTemp);
			strcat(output_middle, "]");
		}
		strcat(output_middle, " = limas_input[*limas_NOW];\n");
		
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "	if(");
		if(buildBlock!=0)
		{	strcat(output_middle, buildBlock);
		}
		else
		{	strcat(output_middle, "1");
		}
		strcat(output_middle, ")\n");
			
		CI+=1;	
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "{	*limas_NOW += 1;\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "}\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "else\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "{	limas_");
			strcat(output_middle, word);
			strcat(output_middle, "[zeroOne]");
			if(isAnycharString)
			{	strcat(output_middle, "[");
				strcat(output_middle, anyIndexVariableTemp);
				strcat(output_middle, "]");
			}
			strcat(output_middle, " = 0;\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "	break;\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "	");
			strcat(output_middle, anyIndexVariableTemp);
			strcat(output_middle, " = 0;\n");
			
			
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "}\n");
		CI-=1;
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "}\n");
		
		if(isAnycharString)
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "limas_");
			strcat(output_middle, word);
			strcat(output_middle, "[zeroOne][");
			strcat(output_middle, anyIndexVariableTemp);
			strcat(output_middle, "] = 0;\n");
		}
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "limas_");
		strcat(output_middle, word);
		strcat(output_middle, "_max[zeroOne] = ");
		strcat(output_middle, anyIndexVariableTemp);
		strcat(output_middle, ";\n");
		
		forNum += 1;
		return;
	}
	
	// handles only anychar types - passes on non-anychar types to 'handleString'
	void handleWord(char* word, char* buildBlock)
	{		for(int n=0; n < anychar_vars.length; n++)
			{	if(!strcmp(anychar_vars[n], word))
				{	handleAnychar(word, buildBlock, false);
					return;
				}
			}
			for(int n=0; n < anycharString_vars.length; n++)
			{	if(!strcmp(anycharString_vars[n], word))
				{	handleAnychar(word, buildBlock, true);
					return;
				}
			}
			// if not an anychar or anychar[]
			handleString(word);
	}
	
	void handleFunction(char* func)
	{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "if(!");
		strcat(output_middle, func);
		strcat(output_middle, ")\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "{\tcontinue;	// function didn't match\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "}\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "*limas_NOW+=diffTemp;\n\n");
	}
	
	void setupForChoices()
	{	char choiceNum_temp[10];
		
		if(!in_tween && !in_every && !noevery && everyExists)
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "tempLabel=&&T");
			strcat(output_middle, itS(choiceSetNumber, choiceNum_temp));
			strcat(output_middle, ";\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "goto every;\n");
		
			strcat(output_middle, "T");
			strcat(output_middle, itS(choiceSetNumber, choiceNum_temp));
			strcat(output_middle, ":\n");
			
			choiceSetNumber += 1;
		}
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "wordL[zeroOne]=-1;\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "wordL[!zeroOne]=-1;\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "NOWtemp0 = *limas_NOW;\n");
		
		nNumber=0;
		NOWtempNumber=1;
		NOWtempNumbersDeclared=0;
		
		theActions.length=0;	// clear the list of actions
		theLabel.length=0;		// clear the list of labels
		elseNumber = -1;		// -1 means there is no else
		in_else=false;
		wordformNumber=0;
	}
	
	void cleanUpAfterChoices()
	{	char nStringTemp[10];
		for(int n=0; n<wordformNumber; n++)
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			if(n!=0)
			{	strcat(output_middle, "else ");
			}
			if(n != elseNumber)
			{	strcat(output_middle, "if(longest == ");
				strcat(output_middle, itS(n, nStringTemp)); 
				strcat(output_middle, " && wordL[!zeroOne] > -1)");
			}
			strcat(output_middle, "\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			if(n != elseNumber)
			{	strcat(output_middle, "{	*limas_NOW = NOWtemp0 + wordL[!zeroOne];\n");
			}
			else
			{	strcat(output_middle, "{\n");
			}
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, theActions[n]);
			strcat(output_middle, "\n");
			
			if(theLabel[n][0]!=0)
			{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
				strcat(output_middle, "	goto ");
				strcat(output_middle, theLabel[n]);
				strcat(output_middle, ";\n");
			}
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
				strcat(output_middle, "}\n");
		}
		
		if(elseNumber == -1)
		{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "else\n");
			
			strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
			strcat(output_middle, "	goto LIMAsEndOfParseFunction;\n");
		}
	}
	
	void setupForWordform()
	{	strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "do\n");
		
		strcat(output_middle, Smult("\t",CI,sMultTemp),CI);
		strcat(output_middle, "{	*limas_NOW = NOWtemp0;\n");

		CI += 1;
		forNum=0;
	}



