/*	This file was created by Billy Tetrud in February 2008. 
	This file is realeased under version 3 of the GNU Public License. See http://www.gnu.org/licenses/
	A copy of GPLv3 should be distributed with this file.
	Email BillyAtLima@gmail.com if you want to discuss creating a different license.
	Copyright 2008, Billy Tetrud.
	
	This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License 
	as published by the Free Software Foundation; either version 3, or (at your option) any later version.

	This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
*/

#include <stdlib.h>
#include <string.h>

// integer to string
char* itS(int a, char* b)
{	return itoa(a, b, 10);
}

// writes mult copies of a into output
char* Smult(char* a, int mult, char* output)
{	int count=0;
	for(int n=0; n<mult; n++)
	{	for(int m=0; a[m]!=0; m++)
		{	output[count]=a[m];
			count++;
		}
	}
	output[count]=0;
	return output;
}

// concatinates strings
//  atEndOfThis = (atEndOfThis putThis)
// returns a reference to the atEndOfThis string
char* strcat(char* atEndOfThis, char putThis)
{	int len = strlen(atEndOfThis);
	atEndOfThis[len]=putThis;
	atEndOfThis[len+1]=0;
	return atEndOfThis;
}

// tests if every character in 'a' is 'in'
bool allEQ(char* a, char in)
{	int n;
	for(n=0; a[n]!=0; n++)
	{	if(a[n]!=in)
			return false;
	}
	return true;
}

// tests if all characters in the subarray defined by 'index' is 'in'
bool allEQ(char* a, int* index, char in)	// index is a -1 ending array of indecies that correspond to elemetns of a to test
{	for(int n=0; index[n]!=-1; n++)
	{	if(a[index[n]]!=in)
			return false;
	}
	return true;
}

// tests if all characters in 'a' are between 'betweens[0+2*x]' and 'betweens[1+2*x]' for every x
// betweens must have an even number of elements (one for each bound of the range) and be null terminated
int allEQ(char* a, char* betweens)
{	for(int n=0; a[n]!=0; n++)
	{	for(int m=0; betweens[0+m*2]!=0; m++)
		{	if( betweens[0+m*2]<=a[n] && a[n]<= betweens[1+m*2] )
			{	goto continue1;	// continue[1] ;; if found in betweens, start searching next character
			}
		}
		return 0;
		continue1: ;
	}
	return 1;	
}
